<?php
// map global arguments to local array
foreach($GLOBALS["argv"] as $key => $value) {
	$pair = explode("=", $value);
	if (count($pair) == 2) {
		$pair[1] = trim($pair[1], "\"");
		$input[$pair[0]] = $pair[1];
	}
}

// Clean input
$input["destination"] = rtrim($input["destination"], "/");

$versions = array();
$tmp_dir = $GLOBALS["_ENV"]["HOME"].$input["folder"];
$binary_name = $input["binary"];
$app_name = "$binary_name.app";
$old_version = "$binary_name (old version).app";
$tmp_app = $input["destination"]."/$old_version";
$archive_path = "$tmp_dir/$binary_name.zip";
//print_r($input);

/*
function is_dir_osx ($file_name) {
	$dir = true;
	
	if (strrpos($file_name, ".")) {
		$extension = substr($file_name, strrpos($file_name, ".") + 1, strlen($file_name));
		if (($extension != "app") && ($extension != "lproj") && ($extension != "framework")) $dir = false;
	}
	
	if ($file_name == ".DS_Store") $dir = false;
	
	return $dir;
}

function remove_dir($current_dir) {

    if ($dir = @opendir($current_dir)) {
        while (($f = readdir($dir)) !== false) {
	
			if (($f != ".") && ($f != "..")) {
				if (!is_dir_osx($f)) {
					@unlink("$current_dir/$f");
	            } else {
					//print("$current_dir/$f\n");
					remove_dir("$current_dir/$f");
	            }
			}
        }

        closedir($dir);
        @rmdir($current_dir);
    }
} */

function MakeChangesLog ($versions) {
	global $tmp_dir;
	
	if ($handle = @fopen("$tmp_dir/changes.txt", "w+")) {
		$changes = "";
		foreach ($versions as $version) {
			$changes .= "• Changes in ".$version["version"].":\n";
			foreach ($version["changed"] as $line) {
				$changes .= "  - $line\n";
			}
		}
		fwrite($handle, $changes);
	}
	
	//print($changes);
	return "$tmp_dir/changes.txt";
}

// Compares a muli-digit version string
function CompareVersions ($server_version, $client_version) {
	$server_version = explode(".", $server_version);
	$client_version = explode(".", $client_version);
	$compare = 0;
	
	if (count($server_version) > count($client_version)) {
		$digits = count($server_version);
	} else {
		$digits = count($client_version);
	}
	//print("digits $digits\n");
	
	for ($i=0; $i < $digits; $i++) { 
		
		// zero null digits
		if (!isset($client_version[$i])) $client_version[$i] = 0;
		if (!isset($server_version[$i])) $server_version[$i] = 0;
		
		// client is newer than server
		if ($client_version[$i] > $server_version[$i]) {
			$compare = 1;
			break;
		}
		
		// server is newer than client
		if ($server_version[$i] > $client_version[$i]) {
			$compare = -1;
			break;
		}
		
	}
	
	//print($compare);
	return($compare);
}

//CompareVersions("1.1.1", "1.1");
//exit;

// Download the update log
function CheckForUpdates () {
	global $input;
	global $versions;
	global $tmp_dir;
	global $tmp_app;
	global $archive_path;
	
	$version_break = "==========";
	$versions = array();
	$version = array();
	
	print("Checking for updates...\n");
	
	// Trash the temporary directory just in case we were left hanging...
	if (file_exists($tmp_dir)) exec("rm -R $tmp_dir");
	
	// Trash the previous temporary app from the last update
	if (file_exists($tmp_app)) exec("rm -R \"$tmp_app\"");

	
	if ($log = @fopen($input["url"], "rb")) {
		$contents = stream_get_contents($log);
		
		// Parse the log
		$lines = explode("\n", $contents);
		foreach ($lines as $line) {

			if ($line == $version_break) {
				$versions[] = $version;
				$version = array();
			} else {
				$pair = explode("=", $line);
				if ($pair[0] == "changed") {
					$version["changed"][] = $pair[1];
				} else {
					$version[$pair[0]] = $pair[1];
				}
			}
		}

		// Append the final version
		$versions[] = $version;
		$version = array();
		$version_number = $versions[0]["version"];
		//print_r($versions);
		//fclose($log);

		// Compare versions
		if ((CompareVersions($version_number, $input["version"]) == -1) && ($version_number <> $input["skip"])) {
		//if (((float)$version_number > (float)$input["version"]) && ((float)$version_number <> (float)$input["skip"])) {
			print("Downloading version $version_number...\n");

			// Download the latest version
			if ($handle = @fopen($versions[0]["link"], "r")) {

				// Create the temporary directory
				@mkdir($tmp_dir, 0777);
				
				// Make the changes log and return the path
				$change_log = MakeChangesLog($versions);
				
				// Copy the zip archive to disk
				if ($archive = @fopen($archive_path, "w+")) {
					@fwrite($archive, stream_get_contents($handle));

					// Unzip the archive
					// -d$path
					popen("unzip $archive_path -d$tmp_dir", "r");
					
					print("version=$version_number\n");
					print("log=$change_log\n");
					
					fclose($archive);
				}

				fclose($handle);
			} else {
				print("Failed to download $version_number application.\n");
			}
		} else {
			if ($input["skip"] == $version_number) {
				print("Version $version_number is being skipped.");
			} else {
				print("Version $version_number is up to date.");
			}
		}
	} else {
		print("Failed to download changes log.\n");
	}
}

function Install ($install) {
	global $tmp_dir;
	global $input;
	global $app_name;
	global $binary_name;
	global $tmp_app;
	global $old_version;
	
	// Copy the file to the destination
	if ($install) {
		$destination = $input["destination"]."/$app_name";
		
		//exec("say Your new version of $binary_name will be installed shortly.");
	
		// Kill the running program first
		//exec("killall $binary_name");
		
		// Rename the current verion
		if (file_exists($destination)) rename($destination, $tmp_app);
		
		// Move application from tmp directory to destination
		exec("cp -R \"$tmp_dir/$app_name\" \"$destination\"");
		
		// Open the new app
		exec("open $destination");
		
		// Move the tmp app to the trash
		// NOTE: We can't delete the app here beacuse the parent process which launched the script is still alive
		//exec("mv \"$tmp_app\" \"".$GLOBALS["_ENV"]["HOME"]."/.Trash/$old_version\"");
		//exec("rm -R \"$tmp_app\"");
	}
	
	// Remove the temporary directory
	//exec("rm -R $tmp_dir");
}

if ($input["action"] == "check") CheckForUpdates();
if ($input["action"] == "install") Install(true);

?>